import os
import subprocess

def main():

    # Подготовка констант
    FLEX_EXE_PATH = r"C:\tools\win_flex_bison\win_flex.exe"
    BISON_EXE_PATH = r"C:\tools\win_flex_bison\win_bison.exe"
    ANALYZER_NAME = f'calc' # basename .l, .y файлов
    LEXICAL_ANALYZER_PATH = fr"analyzers\{ANALYZER_NAME}.l"
    SYNTAXIC_ANALYZER_PATH = fr"analyzers\{ANALYZER_NAME}.y"
    #

    # Подготовка списка команд
    cmds = [f'{FLEX_EXE_PATH} {LEXICAL_ANALYZER_PATH}',
            f'{BISON_EXE_PATH} -d {SYNTAXIC_ANALYZER_PATH}',
            f'gcc lex.yy.c {ANALYZER_NAME}.tab.c -o {ANALYZER_NAME}.exe']
    #

    # Исполнение команд
    for cmd in cmds:
        try:
            subprocess.run(cmd, capture_output=True, check=True)
            print(f'\033[92mSuccess execute {cmd}!\033[0m')
        except subprocess.CalledProcessError as e:
            print(f"\033[91mError during export: {e}\033[0m")
    #

    # Очистка
    for path in ['lex.yy.c', 
                 f'{ANALYZER_NAME}.tab.c', 
                 f'{ANALYZER_NAME}.tab.h']:
        os.remove(path)
    #

if __name__ == "__main__":
    main()